import numpy as np
from cdt.metrics import SID, SHD

def backRE(tar_DAG, P_KCI):
    sid_val1 = SID(tar_DAG, P_KCI)
    sid_val2 = SID(P_KCI, tar_DAG)
    shd_val = SHD(tar_DAG, P_KCI)
    precision, recall, f1 = f1_score(tar_DAG, P_KCI)
    distance = l2_distance(tar_DAG, P_KCI)
    return [sid_val1, sid_val2, shd_val, precision, recall, f1, distance]

def f1_score(y_true, y_pred):
    true_positive = np.sum((y_true == 1) & (y_pred == 1))
    precision = true_positive / (np.sum(y_pred == 1) + 1e-10)
    recall = true_positive / (np.sum(y_true == 1) + 1e-10)
    f1 = 2 * precision * recall / (precision + recall + 1e-10)
    return precision, recall, f1

def l2_distance(point1, point2):
    point1 = np.array(point1)
    point2 = np.array(point2)
    distance = np.sqrt(np.sum((point1 - point2)**2))
    return distance